﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.Linq;
using System.ServiceProcess;
using System.Text;
using SpeedTestDll;
using System.Threading;

namespace SpeedTestSvc
{
    public partial class SpeedTestSvc : ServiceBase
    {
        private System.ComponentModel.IContainer components = null;
        public SpeedTest bgb = null;

        public SpeedTestSvc()
        {
            this.ServiceName = "SpeedTestSvc";
            InitializeComponent();
        }

        protected override void OnStart(string[] args)
        {
            bgb = new SpeedTest(49986, "SpeedTest Server");
            bgb.Start();

            ThreadStart ts = new ThreadStart(MonitorThread);
            Thread t = new Thread(ts);
            t.Start();
        }

        protected override void OnStop()
        {
            this.bgb.Stop();
            //this.bgb.shuttingDown = true;
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        private void InitializeComponent()
        {
            this.ServiceName = "SpeedTestSvc";
        }

        private void MonitorThread()
        {
            long start = 0;
            while (bgb != null && bgb.GetShuttingDown() == false)
            {
                Thread.Sleep(1000 * 30); //every 30 seconds

                if (start >= (1000 * 60 * 60 * 6) || start == 0)
                {
                    start = 0;
                    try
                    {
                        //I am still alive code here.
                        //System.Net.Mail.SmtpClient sender = new System.Net.Mail.SmtpClient("127.0.0.1");
                        //sender.Send("status_check@middlemindgames.com", "webapps@middlemindgames.com", "Status Check: Mcm", "I am still running. " + System.DateTime.Now.ToLongDateString() + " " + System.DateTime.Now.ToLongTimeString());
                    }
                    catch { }
                }

                start += (1000 * 30);
            }
        }
    }
}
